﻿'程序目标（请按照步骤依次实现，以便粗略的得到程序改进的效果）：
'1、实现棋盘剪裁。上一版本代码中已经使用了棋盘剪裁技术。
'2、实现迭代加深。实现后迭代加深步数为5。
'3、实现空步剪裁。实现后迭代加深步数为5,6,7。
'4、实现冲棋延伸。实现后惨不忍睹……迭代加深为4,5。

Imports System.Windows.Forms
Imports System.Drawing
Imports System.Runtime.InteropServices

Public Class Form1
    '黑白棋子
    Private bb As Bitmap
    Private bw As Bitmap
    '棋子偏移
    Private co As Point = New Point(5, 5)
    '棋子大小
    Private cs As Size = New Size(25, 25)
    '引擎
    Dim ab As mAlphaBeta
    '线程
    Dim th As Threading.Thread
    '引擎刚走的棋坐标
    Dim pcpoint As Integer

    Private Sub frmhero_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        '初始化棋盘位图
        pnlBoard.BackgroundImage = My.Resources._2064
        '初始化棋子
        Dim resbmp As Bitmap = New Bitmap(My.Resources._7041, cs.Width * 4, cs.Height)
        Dim allbmp As Bitmap = New Bitmap(resbmp.Width \ 2, resbmp.Height)
        For y As Integer = 0 To allbmp.Height - 1
            For x As Integer = 0 To allbmp.Width - 1
                If resbmp.GetPixel(x + allbmp.Width, y).ToArgb = Color.Black.ToArgb Then allbmp.SetPixel(x, y, resbmp.GetPixel(x, y))
            Next
        Next
        bb = allbmp.Clone(New Rectangle(0, 0, allbmp.Width / 2, allbmp.Height), allbmp.PixelFormat)
        bw = allbmp.Clone(New Rectangle(allbmp.Width / 2, 0, allbmp.Width / 2, allbmp.Height), allbmp.PixelFormat)
        '初始化开具布局(暂时先用恒星）
        Dim pos As New mPosition
        pos.Startup()
        '开局棋型可在这里设置==========================================================
        ab = New mAlphaBeta(pos)
        ab.pos.AddPiece(7 * 15 + 7)
        pcpoint = 7 * 15 + 7
        '关闭线程提示
        Control.CheckForIllegalCrossThreadCalls = False
    End Sub

    Private Sub Form1_FormClosing(sender As Object, e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        Me.Hide()
        If th IsNot Nothing Then th.Abort()
    End Sub

    '绘制棋子
    Private Sub pnlBoard_Paint(sender As System.Object, e As System.Windows.Forms.PaintEventArgs) Handles pnlBoard.Paint
        For i As Integer = 0 To 224
            If ab.pos.ucpcSquares.Get(i) = 1 Then e.Graphics.DrawImage(bb, New Point((i Mod 15) * cs.Height, (i \ 15) * cs.Height) + co)
            If ab.pos.ucpcSquares.Get(i) = 0 Then e.Graphics.DrawImage(bw, New Point((i Mod 15) * cs.Height, (i \ 15) * cs.Height) + co)
        Next
        If pcpoint >= 0 AndAlso pcpoint <= 225 Then
            e.Graphics.DrawArc(Pens.Blue, New Rectangle((pcpoint Mod 15) * cs.Height + co.X, (pcpoint \ 15) * cs.Height + co.Y, cs.Height, cs.Height), 0, 360)
        End If
    End Sub

    '下子
    Private Sub pnlBoard_MouseDown(sender As Object, e As System.Windows.Forms.MouseEventArgs) Handles pnlBoard.MouseDown
        If ab.winplayr <> 2 Then Return
        Dim sdr = CType(sender, Panel)
        Dim p As Point = e.Location - co
        p.X \= cs.Width
        p.Y \= cs.Height
        If e.Button = Windows.Forms.MouseButtons.Left AndAlso ab.pos.sdPlayer = 0 Then
            pcpoint = -1
            ab.pos.AddPiece(p.Y * 15 + p.X)
            pnlBoard.Refresh()
            If (th Is Nothing) OrElse (Not th.IsAlive) Then
                th = New Threading.Thread(AddressOf pcgo)
                th.Start()
            End If
        End If
    End Sub

    '电脑走棋
    Sub pcgo()
        pcpoint = ab.SearchMain()
        ab.pos.ucpcSquares.Set(pcpoint, 1)
        ab.pos.ChangeSide()
        pnlBoard.Refresh()
        If ab.winplayr = 1 Then
            MsgBox("你输了")
        ElseIf ab.winplayr = 0 Then
            MsgBox("电脑认输")
        End If
    End Sub

End Class

