﻿'1、实现位棋盘（坐标是一维的，因为用一维坐标表示棋盘可以节省很多不必要的y*l+x计算。）
Public Class mBitBoard
    '用bitarray代替byte数组，提高读写速度。（bitarray内部实现是用integer数组，每一个元素是32字节，所以寻址速度要比用byte数组快很多）
    '0=白方，1=黑方，2=空
    Private wBitArr As BitArray
    Private bBitArr As BitArray
    '15*15的棋盘。
    Sub New()
        wBitArr = New BitArray(225)
        bBitArr = New BitArray(225)
    End Sub

    '设置棋子
    Sub [Set](index As Integer, value As Integer)
        If value = 0 Then
            wBitArr.Set(index, True)
        ElseIf value = 1 Then
            bBitArr.Set(index, True)
        Else
            bBitArr.Set(index, False)
            wBitArr.Set(index, False)
        End If
    End Sub

    '获取棋子
    Function [Get](index As Integer) As Integer
        If wBitArr.Get(index) Then Return 0
        If bBitArr.Get(index) Then Return 1
        Return 2
    End Function

    '获取合理招法棋盘
    Public Function GetGeneratePoints() As BitArray
        Dim tmp As New BitArray(225)
        For x1 As Integer = 0 To 14
            For y1 As Integer = 0 To 14
                If bBitArr.Get(x1 + y1 * 15) OrElse wBitArr(x1 + y1 * 15) Then
                    For y As Integer = -3 To 3
                        For x As Integer = -3 To 3
                            Dim tx As Integer = x1 + x
                            Dim ty As Integer = y1 + y
                            If tx > -1 AndAlso ty > -1 AndAlso tx < 14 AndAlso ty < 14 Then
                                If bBitArr.Get(tx + ty * 15) = False AndAlso wBitArr.Get(tx + ty * 15) = False Then
                                    tmp.Set(tx + ty * 15, True)
                                End If
                            End If
                        Next
                    Next
                End If
            Next
        Next
        Return tmp
    End Function

End Class
