﻿Public Class mPosition
    '72成棋向量
    Public Vectors As New mVectors
    '轮到谁走，0=红方，1=黑方
    Public sdPlayer As Integer 
    '棋盘上的棋子，0=红方，1=黑方，2=无子
    Public ucpcSquares As mBitBoard
    '距离根节点的步数
    Public nDistance As Integer
    '禁手玩家
    Public RtPlayer As Integer = 2
    '电脑走的棋
    Public mvResult As Integer
    '历史表
    Public nHistoryTable(224) As Integer

    '初始化棋盘类
    Sub New()
        ucpcSquares = New mBitBoard()
    End Sub

    '清空历史表
    Public Sub ClearnHistoryTable()
        mvResult = 0
        Array.Clear(nHistoryTable, 0, 225)
    End Sub

    '交换走棋者
    Sub ChangeSide()
        sdPlayer = 1 - sdPlayer
    End Sub

    '在棋盘上放一枚棋子
    Sub AddPiece(sq As Integer)
        '更新棋盘
        ucpcSquares.Set(sq, sdPlayer)
        '更新更新标志和向量上棋子个数
        For Each v As mVector In Vectors.hs(sq)
            v.pipecount(ucpcSquares.Get(sq)) += 1
            v.update = True
        Next
        '交换走棋方
        ChangeSide()
        '更新步数
        nDistance += 1
    End Sub

    '从棋盘上拿走一枚棋子
    Sub DelPiece(sq As Integer)
        For Each v As mVector In Vectors.hs(sq)
            v.pipecount(ucpcSquares.Get(sq)) -= 1
            v.update = True
        Next
        ucpcSquares.Set(sq, 2)
        ChangeSide()
        nDistance -= 1
    End Sub

    '局面评价函数
    Function Evaluate() As Integer
        Return Vectors.Evaluate(ucpcSquares, sdPlayer, RtPlayer)
    End Function

    Sub Startup()  '初始化棋盘
        sdPlayer = 1
        nDistance = 0
        For i As Integer = 0 To 224 '没有使用bitarray的setall函数。
            ucpcSquares.Set(i, 2)
        Next
    End Sub

    'mvs为全部合理招法
    Function GenerateMoves(mvs() As Byte) As Integer  '生成所有走法
        Dim GenBoard = ucpcSquares.GetGeneratePoints
        Dim i As Integer = 0, nGenMoves As Integer = 0
        For i = 0 To 224
            If GenBoard(i) Then
                mvs(nGenMoves) = i
                nGenMoves += 1
            End If
        Next
        Return nGenMoves - 1
    End Function

    '=========================空步============================
    '代码很简单，就是把添子和删子里面更新棋盘过程去掉了，而只交换玩家和增加深度。当然这也导致重新评价得分是无意义的。
    Sub NullMove()  '走一步空步
        ChangeSide()
        nDistance += 1
    End Sub
    '撤消走一步空步
    Sub UnNullMove()
        ChangeSide()
        nDistance -= 1
    End Sub
    '=========================空步结束==========================

End Class
