﻿'1、实现向量——获取对应的棋盘点坐标
'2、实现向量上双方棋型评价——得到具体棋型以便双方72向量统计起来后进行比较得到评分
'3、实现冲棋点获取——这有利于冲棋局面的评价，因为冲棋局面的解就是冲棋点

Imports System.Runtime.InteropServices

Public Class mVector
    Public update As Boolean
    '棋型评价结果。0=白方，1=黑方
    Public linkInfs(1) As LinkInfo
    '向量上的全部坐标
    Public ps() As Byte
    '向量上白棋、黑棋的个数
    Public pipecount(1) As Byte
    '向量数组，由mvectors类初始化。
    Sub New(parr() As Byte)
        ps = parr
        linkInfs(0) = New LinkInfo
        linkInfs(1) = New LinkInfo
    End Sub

    '评价向量的当前情况
    Sub Evaluate(ucpc As mBitBoard)
        '向量点数组最大下标
        Dim infend As Integer = ps.Length - 1
        '循环变量
        Dim i As Integer
        '白方、黑方在向量上的子分布信息
        Dim inf0(infend) As Byte
        Dim inf1(infend) As Byte
        '循环访问向量上指向的棋盘点
        For i = 0 To infend
            If ucpc.Get(ps(i)) = 1 Then         '黑子
                inf0(i) = 2
                inf1(i) = 1
            ElseIf ucpc.Get(ps(i)) = 0 Then     '白子
                inf0(i) = 1
                inf1(i) = 2
            Else                                '无子
                inf0(i) = 0
                inf1(i) = 0
            End If
        Next
        '白子棋型
        linkInfs(0) = EvaluateShape(inf0, 0, infend, pipecount(0))
        '更新冲棋点坐标为棋盘坐标
        For i = 0 To linkInfs(0).cqpend
            linkInfs(0).cqp(i) = ps(linkInfs(0).cqp(i))
        Next
        '黑子棋型
        linkInfs(1) = EvaluateShape(inf1, 0, infend, pipecount(1))
        For i = 0 To linkInfs(1).cqpend
            linkInfs(1).cqp(i) = ps(linkInfs(1).cqp(i))
        Next
    End Sub

    '========================================棋型评价的实现============================================

    '棋型模板定义
    '长连
    Private Shared mll1() As Byte = New Byte() {1, 1, 1, 1, 1, 1}
    Private Shared mll2() As Byte = New Byte() {1, 1, 1, 1, 1, 1, 1}
    Private Shared mll3() As Byte = New Byte() {1, 1, 1, 1, 1, 1, 1, 1}
    Private Shared mll4() As Byte = New Byte() {1, 1, 1, 1, 1, 1, 1, 1, 1}
    '成5
    Private Shared ml5() As Byte = New Byte() {1, 1, 1, 1, 1}
    '活4
    Private Shared ml42() As Byte = New Byte() {0, 1, 1, 1, 1, 0}
    '冲4
    Private Shared ml41a() As Byte = New Byte() {0, 1, 1, 1, 1}
    Private Shared ml41b() As Byte = New Byte() {1, 0, 1, 1, 1}
    Private Shared ml41c() As Byte = New Byte() {1, 1, 0, 1, 1}
    Private Shared ml41d() As Byte = New Byte() {1, 1, 1, 0, 1}
    Private Shared ml41e() As Byte = New Byte() {1, 1, 1, 1, 0}
    '活3
    Private Shared ml32a() As Byte = New Byte() {0, 0, 1, 1, 1, 0, 0}
    Private Shared ml32b() As Byte = New Byte() {0, 0, 1, 1, 0, 1, 0}
    Private Shared ml32c() As Byte = New Byte() {0, 1, 0, 1, 1, 0, 0}
    Private Shared ml32d() As Byte = New Byte() {0, 0, 1, 1, 1, 0}
    Private Shared ml32e() As Byte = New Byte() {0, 1, 0, 1, 1, 0}
    Private Shared ml32f() As Byte = New Byte() {0, 1, 1, 0, 1, 0}
    Private Shared ml32g() As Byte = New Byte() {0, 1, 1, 1, 0, 0}
    '冲3
    Private Shared ml31a() As Byte = New Byte() {0, 0, 1, 1, 1}
    Private Shared ml31b() As Byte = New Byte() {1, 1, 1, 0, 0}
    Private Shared ml31c() As Byte = New Byte() {0, 1, 1, 0, 1}
    Private Shared ml31d() As Byte = New Byte() {0, 1, 0, 1, 1}
    '活2
    Private Shared ml22a() As Byte = New Byte() {0, 1, 1, 0, 0, 0}
    Private Shared ml22b() As Byte = New Byte() {0, 0, 1, 1, 0, 0}
    Private Shared ml22c() As Byte = New Byte() {0, 0, 0, 1, 1, 0}
    Private Shared ml22d() As Byte = New Byte() {0, 1, 0, 1, 0, 0}
    Private Shared ml22e() As Byte = New Byte() {0, 0, 1, 0, 1, 0}
    Private Shared ml22f() As Byte = New Byte() {0, 1, 1, 0, 0}
    Private Shared ml22g() As Byte = New Byte() {0, 0, 1, 1, 0}
    Private Shared ml22h() As Byte = New Byte() {0, 1, 0, 1, 0}
    '冲2
    Private Shared ml21a() As Byte = New Byte() {1, 1, 0, 0, 0}
    Private Shared ml21b() As Byte = New Byte() {0, 0, 0, 1, 1}

    'inf信息，infstart,infend为inf中用于评分的起止位置，l评分器，count为匹配位置。发现评分器返回true，否则返回false。
    Private Shared Function CompareArray(inf As Byte(), infstart As Integer, infend As Integer, l As Byte(), ByRef count As Integer) As Boolean
        Dim len As Integer = infend - infstart + 1 - l.Length   'inf数组有用长度与模板长度差
        If len < 0 Then Return False
        Dim i As Integer
        Dim l1 As Integer = l.Length
        '遍历inf每个位置与当前模板对比
        Dim tmp As Boolean
        For i = 0 To len
            tmp = True
            For j = 0 To l.Length - 1
                If inf(j + i) <> l(j) Then
                    tmp = False
                    Exit For
                End If
            Next
            If tmp Then   '当匹配长度为模板长度才说明匹配了模板。
                count = i
                Return True '从i开始模板长度上与模板匹配字节数=模板长度说明匹配当前模板。
            End If
        Next
        count = -1
        Return False
    End Function

    '根据模板进行棋型获取（匹配最高连即返回）。
    Private Shared Function EvaluateShape(inf As Byte(), infstart As Integer, infend As Integer, pipecount As Byte) As LinkInfo
        Dim count As Integer
        Dim lnkinf As New LinkInfo

        '长连
        If pipecount > 5 Then
            If CompareArray(inf, infstart, infend, mll1, count) Then
                lnkinf.lnk = 60
                Return lnkinf
            End If

            If CompareArray(inf, infstart, infend, mll2, count) Then
                lnkinf.lnk = 60
                Return lnkinf
            End If

            If CompareArray(inf, infstart, infend, mll3, count) Then
                lnkinf.lnk = 60
                Return lnkinf
            End If

            If CompareArray(inf, infstart, infend, mll4, count) Then
                lnkinf.lnk = 60
                Return lnkinf
            End If
        End If

        '成5
        If pipecount > 4 Then
            If CompareArray(inf, infstart, infend, ml5, count) Then
                lnkinf.lnk = 50
                Return lnkinf
            End If
        End If

        '活4
        If pipecount > 3 Then
            If CompareArray(inf, infstart, infend, ml42, count) Then
                lnkinf.lnk = 42
                '在这里记录的冲棋坐标是inf的下标，也是ps的下标，而不是实际棋盘坐标。
                '虽然可以用循环来找到模板当中的0，但是比硬编码要慢很多。
                lnkinf.cqp(0) = count
                lnkinf.cqp(1) = count + 5
                lnkinf.cqpend = 1
                Return lnkinf
            End If

            '冲4
            If CompareArray(inf, infstart, infend, ml41a, count) Then
                lnkinf.lnk = 41
                lnkinf.cqp(0) = count
                lnkinf.cqpend = 0
                Return lnkinf
            End If

            If CompareArray(inf, infstart, infend, ml41b, count) Then
                lnkinf.lnk = 41
                lnkinf.cqp(0) = count + 1
                lnkinf.cqpend = 0
                Return lnkinf
            End If

            If CompareArray(inf, infstart, infend, ml41c, count) Then
                lnkinf.lnk = 41
                lnkinf.cqp(0) = count + 2
                lnkinf.cqpend = 0
                Return lnkinf
            End If

            If CompareArray(inf, infstart, infend, ml41d, count) Then
                lnkinf.lnk = 41
                lnkinf.cqp(0) = count + 3
                lnkinf.cqpend = 0
                Return lnkinf
            End If

            If CompareArray(inf, infstart, infend, ml41e, count) Then
                lnkinf.lnk = 41
                lnkinf.cqp(0) = count + 4
                lnkinf.cqpend = 0
                Return lnkinf
            End If
        End If

        '活3
        If pipecount > 2 Then
            If CompareArray(inf, infstart, infend, ml32a, count) Then
                lnkinf.lnk = 32
                lnkinf.cqp(0) = count
                lnkinf.cqp(1) = count + 1
                lnkinf.cqp(2) = count + 5
                lnkinf.cqp(3) = count + 6
                lnkinf.cqpend = 3
                Return lnkinf
            End If

            If CompareArray(inf, infstart, infend, ml32b, count) Then
                lnkinf.lnk = 32
                lnkinf.cqp(0) = count
                lnkinf.cqp(1) = count + 1
                lnkinf.cqp(2) = count + 4
                lnkinf.cqp(3) = count + 6
                lnkinf.cqpend = 3
                Return lnkinf
            End If

            If CompareArray(inf, infstart, infend, ml32c, count) Then
                lnkinf.lnk = 32
                lnkinf.cqp(0) = count
                lnkinf.cqp(1) = count + 2
                lnkinf.cqp(2) = count + 5
                lnkinf.cqp(3) = count + 6
                lnkinf.cqpend = 3
                Return lnkinf
            End If

            If CompareArray(inf, infstart, infend, ml32d, count) Then
                lnkinf.lnk = 32
                lnkinf.cqp(0) = count
                lnkinf.cqp(1) = count + 1
                lnkinf.cqp(2) = count + 5
                lnkinf.cqpend = 2
                Return lnkinf
            End If

            If CompareArray(inf, infstart, infend, ml32e, count) Then
                lnkinf.lnk = 32
                lnkinf.cqp(0) = count
                lnkinf.cqp(1) = count + 2
                lnkinf.cqp(2) = count + 5
                lnkinf.cqpend = 2
                Return lnkinf
            End If

            If CompareArray(inf, infstart, infend, ml32f, count) Then
                lnkinf.lnk = 32
                lnkinf.cqp(0) = count
                lnkinf.cqp(1) = count + 3
                lnkinf.cqp(2) = count + 5
                lnkinf.cqpend = 2
                Return lnkinf
            End If

            If CompareArray(inf, infstart, infend, ml32g, count) Then
                lnkinf.lnk = 32
                lnkinf.cqp(0) = count
                lnkinf.cqp(1) = count + 4
                lnkinf.cqp(2) = count + 5
                lnkinf.cqpend = 2
                Return lnkinf
            End If

            '冲3
            If CompareArray(inf, infstart, infend, ml31a, count) Then
                lnkinf.lnk = 31
                lnkinf.cqp(0) = count
                lnkinf.cqp(1) = count + 1
                lnkinf.cqpend = 1
                Return lnkinf
            End If

            If CompareArray(inf, infstart, infend, ml31b, count) Then
                lnkinf.lnk = 31
                lnkinf.cqp(0) = count + 3
                lnkinf.cqp(1) = count + 4
                lnkinf.cqpend = 1
                Return lnkinf
            End If

            If CompareArray(inf, infstart, infend, ml31c, count) Then
                lnkinf.lnk = 31
                lnkinf.cqp(0) = count
                lnkinf.cqp(1) = count + 3
                lnkinf.cqpend = 1
                Return lnkinf
            End If

            If CompareArray(inf, infstart, infend, ml31d, count) Then
                lnkinf.lnk = 31
                lnkinf.cqp(0) = count
                lnkinf.cqp(1) = count + 2
                Return lnkinf
            End If
        End If

        '活2
        If pipecount > 1 Then
            If CompareArray(inf, infstart, infend, ml22a, count) Then
                lnkinf.lnk = 22
                lnkinf.cqp(0) = count
                lnkinf.cqp(1) = count + 3
                lnkinf.cqp(2) = count + 4
                lnkinf.cqpend = 3
                Return lnkinf
            End If

            If CompareArray(inf, infstart, infend, ml22b, count) Then
                lnkinf.lnk = 22
                lnkinf.cqp(0) = count
                lnkinf.cqp(1) = count + 1
                lnkinf.cqp(2) = count + 4
                lnkinf.cqp(2) = count + 5
                lnkinf.cqpend = 3
                Return lnkinf
            End If

            If CompareArray(inf, infstart, infend, ml22c, count) Then
                lnkinf.lnk = 22
                lnkinf.cqp(0) = count + 1
                lnkinf.cqp(1) = count + 2
                lnkinf.cqp(2) = count + 5
                lnkinf.cqpend = 2
                Return lnkinf
            End If

            If CompareArray(inf, infstart, infend, ml22d, count) Then
                lnkinf.lnk = 22
                lnkinf.cqp(0) = count
                lnkinf.cqp(1) = count + 2
                lnkinf.cqp(2) = count + 4
                lnkinf.cqpend = 2
                Return lnkinf
            End If

            If CompareArray(inf, infstart, infend, ml22e, count) Then
                lnkinf.lnk = 22
                lnkinf.cqp(0) = count + 1
                lnkinf.cqp(1) = count + 3
                lnkinf.cqp(2) = count + 5
                lnkinf.cqpend = 2
                Return lnkinf
            End If

            If CompareArray(inf, infstart, infend, ml22f, count) Then
                lnkinf.lnk = 22
                lnkinf.cqp(0) = count
                lnkinf.cqp(1) = count + 3
                lnkinf.cqp(2) = count + 4
                lnkinf.cqpend = 2
                Return lnkinf
            End If

            If CompareArray(inf, infstart, infend, ml22g, count) Then
                lnkinf.lnk = 22
                lnkinf.cqp(0) = count
                lnkinf.cqp(1) = count + 1
                lnkinf.cqp(2) = count + 4
                lnkinf.cqpend = 2
                Return lnkinf
            End If

            If CompareArray(inf, infstart, infend, ml22h, count) Then
                lnkinf.lnk = 22
                lnkinf.cqp(0) = count
                lnkinf.cqp(1) = count + 2
                lnkinf.cqp(2) = count + 4
                lnkinf.cqpend = 2
                Return lnkinf
            End If

            '冲2
            If CompareArray(inf, infstart, infend, ml21a, count) Then
                lnkinf.lnk = 21
                lnkinf.cqp(0) = count + 2
                lnkinf.cqp(1) = count + 3
                lnkinf.cqp(2) = count + 4
                lnkinf.cqpend = 2
                Return lnkinf
            End If

            If CompareArray(inf, infstart, infend, ml21b, count) Then
                lnkinf.lnk = 21
                lnkinf.cqp(0) = count + 0
                lnkinf.cqp(1) = count + 1
                lnkinf.cqp(2) = count + 2
                lnkinf.cqpend = 2
                Return lnkinf
            End If

        End If
        '其他
        Return lnkinf
    End Function


End Class

'棋型评价信息
Public Class LinkInfo
    '棋型
    Public lnk As Integer
    '冲棋坐标
    '技巧：已知数组需要的最大长度为4，用一个变量表示用到的最大下标，避免redim语句——它耗时太多了。
    Public cqp(3) As Byte
    '冲棋坐标结束下标
    Public cqpend As Integer

    Sub New()
        cqpend = -1
    End Sub

End Class